import { Container } from 'inversify';
import TokenController from '../controllers/token.controller.js';
import { APIGatewayProxyEvent } from 'aws-lambda';
import { HTTP_STATUS_405 } from '../constants.js';
import { TEndpoint } from '../common/types/endpoint.type.js';

export const ENDPOINT_RESPONSE = (container: Container, endpoint: string, event: APIGatewayProxyEvent) => {
    const isEndpoint = validateEndpoint(endpoint);

    if (!isEndpoint) {
        return {
            statusCode: HTTP_STATUS_405,
            body: 'Not allowed',
        };
    }

    const endpointAux = endpoint as TEndpoint;

    const tokenController = container.get<TokenController>(TokenController.name);

    const endpointSwitcher = {
        'POST|/v1/token': () => tokenController.createOne(event),
        'GET|/v1/token': () => tokenController.findOneByAutoGeneratedToken(event)
    };

    const endpointCase = endpointSwitcher[endpointAux];
    return endpointCase();
};

const validateEndpoint = (endpoint: string) => {
    const endpoints = [
        'POST|/v1/token',
        'GET|/v1/token',
    ];

    const isEndpoint = endpoints.includes(endpoint);
    return isEndpoint;
};
